#################################################################################################################################
#Выгрузка для сайта Стандарт-М 987439 08-04-2021 А.К. ТЗ во вложении к заявке
#описание и фото приходят по синхронизации от профиля 101 (новая база в Аптеке 16), сами фотки доступны по шаре
#################################################################################################################################

#C:\Users\Standart\PycharmProjects\pythonProject\venv\Scripts\pip install pycurl
import declare
import fdb
import lan_fdb
import json
from ftplib import FTP
import zipfile
import os
import requests
import sys
import pycurl
import logging
import time
import certifi
import shutil
import os
from os.path import join, getsize
from PIL import Image


def LogIt(text,status=None):
    with open(declare.dir+'log.txt', 'a')as log:
        log_string = time.strftime("%d.%m.%y %H:%M:%S")
        log_string = log_string +' '+ text + "\n"
        log.write(log_string)
    print(log_string)

LogIt("Начало выгрузки")

#exit()

# init connect to database
conn = fdb.connect(host=declare.host, database=declare.db_file, user='sysdba', password='masterkey')
curs = conn.cursor()

#################################################################################################################################
#0 копируем файлы с фото из расшаренной папки аптеки 16 локально на сервер
LogIt("1 собираем список всех файлов на удаленной машине "+declare.dir_pic_remote)

#собираем список всех файлов на удаленной машине
folder = []
for i in os.walk(declare.dir_pic_remote):
    folder.append(i)

#проверка новых фото, если файла локально нет, то его копируем в dir_pic_curr
LogIt("2 проверка новых фото, если файла локально нет, то его копируем в "+declare.dir_pic_curr+"_pict/")
i=0
for address, dirs, files in folder:
     for file in files:
         if '/back' not in address:
             if not os.path.isfile(declare.dir_pic_all + "\\"+file):
                 if i < declare.cnt_new_photo:
                   shutil.copyfile(address+'/'+file, declare.dir_pic_curr+"_pict/"+'/'+file, follow_symlinks=True)
                   i=i+1
#print(address+'/'+file)

LogIt("3 сжимаем новые фото в папке "+declare.dir_pic_curr+"_pict/")
#сжимаем фото в папке dir_pic_curr
for root, dirs, files in os.walk(declare.dir_pic_curr+"_pict/"):
    for f in files:
        try:
            with Image.open(join(root, f)) as im:
                    im.save(join(root, f),optimize=True,quality=60)
            im.close()
        except IOError:
            pass
LogIt("4 окончание копирования и сжатия новых фото")


#################################################################################################################################
#1 stores - выгрузка справочника аптек
LogIt("5 stores - выгрузка справочника аптек")
#store_id | guid
#name | string
#address | string
#phone | string
#work_hours | string
#lat | double
#lon | double
#legal_name | string
#legal_id | string (ОГРН, ОГРНИП)

sql = "select id," \
      "caption as name," \
      "(select param_value from params p where p.g$profile_id=g.id and p.param_id = 'ORG_ADRESS' ) as address," \
      "(select param_value from params p where p.g$profile_id=g.id and p.param_id = 'ORG_PHONE' ) as phone " \
      "from G$PROFILES g where dbsecurekey is not null and relationtype=1 and dbsecurekey not containing '!' and id <> 100 " \
      " and exists(select part_id from warebase_g w where quant > 1 and w.g$profile_id = g.id)"
LogIt(sql)

result = lan_fdb.get_sql(curs, sql)
res=[]
for line in result:
    res.append({"id":line[0],"name":line[1],"address":line[2],"phone":line[3]})
#print(res)

filename =declare.dir+"stores.json"
with open(filename, 'w', encoding='cp1251') as f:
     json.dump(res, f, ensure_ascii=False, indent=4)

#################################################################################################################################
LogIt("6 catalog - выгрузка справочника товаров СЛС, которые привязаны к справочнику номенклатуры")
#2 catalog - выгрузка справочника товаров СЛС, которые привязаны к справочнику номенклатуры
#catalog_id | guid
#name | string
#synonyms | array of strings - синонимы к названию лекарства
#group | array of int (не используется) - группы
#n1 | string - состав
#n2 | string - действие
#n3 | string - побочное действие
#n4 | string - взаимодействие
#n5 | string - показания к применению
#n6 | string - противопоказания
#n7 | string - применение
#n8 | string - лекарственные формы
#n9 | string - условия хранения
#n10 | image_id (guid) - фото
#n11 | string - производители
#n12 | int (не используется) - фармгруппа
#n13 | string - международное непатентованное наименование
#n14 | string - передозировка
#n15 | string - особые указания
#n16 | string - фармокинетика
#ndx1 | string - показания к применению
#ndx2 | string - действие
#photo_id| string - фото (пример ID=66 у "Адонис бром", фото имеет имя fi0000066.jpg)

#sql = "select CID, PNAME, SYNONIM, GROUP_ID, N1,N2,N3,N4,N5,N6,N7,N8,N9,N10,N11,N12,N13,N14,N15,N16,NDX1,NDX2, id as photo_id  from site_source ss where "\
#                    " exists(select cid from site_wares_source sws where sws.cid = ss.cid)"
sql = "select ID as CID, PNAME, SYNONIM, 0 as GROUP_ID, N1,N2,N3,N4,N5,N6,N7,N8,N9,N10,N11,N12,N13,N14,N15,N16,NDX1,NDX2, id as photo_id  from PI$PHARMINFO ph where"\
          " exists(select id from PI$BARCODES pb where pb.pi_id = ph.id)"

LogIt(sql)
result = lan_fdb.get_sql(curs, sql)
res=[]
for line in result:
    res.append({"catalog_id":line[0],"name":line[1],"synonyms":line[2],"group":line[3],"n1":line[4],"n2":line[5],"n3":line[6],"n4":line[7],"n5":line[8],"n6":line[9],"n7":line[10],"n8":line[11],"n9":line[12],"n10":line[13],"n11":line[14],"n12":line[15],"n13":line[16],"n14":line[17],"n15":line[18],"n16":line[19],"ndx1":line[20],"ndx2":line[21],"photo_id":line[22]})
#print(res)

filename =declare.dir+"catalog.json"
with open(filename, 'w', encoding='cp1251') as f:
     json.dump(res, f, ensure_ascii=False, indent=4)

#################################################################################################################################
#3 nomenclature - выгрузка текущих остатков
LogIt("7 nomenclature - выгрузка текущих остатков")
#/api/v1/nomenclature - справочник товаров
#0 nomenclature_id | guid
#1 catalog_id | guid
#2 barcode | string
#3 manufacturer | string
#4 country | string
#5 price | double
#6 expiration_date | date
#7 group_id | array of int
#8 sname | string
#9 photo_id | array of string

#      "(select list(distinct gd.group_id) from group_detail gd left join groups g on g.id = gd.group_id and g.grouptable=gd.grouptable "\
#      "   where gd.grouptable_id = cast(w.name_id as dm_text) and gd.grouptable='PARTS.NAME_ID' and (g.parent_id =2073 or ((select first 1 g2.parent_id from groups g2 where g2.id = g.parent_id) = 2073)) ) as group_id,"\

#photo_id - по фото только формат .jpg заложили, как у Булатова, например
#"(select s.cid from site_wares_source s where s.ware_id = w.ware_id) as  catalog_id,"\
sql = "select ware_id as nomenclature_id,"\
      "(select pi_id from PI$BARCODES pb where pb.barcode = w.bcode_izg) as  catalog_id,"\
      "bcode_izg as barcode,"\
      "sizg as manufacturer,"\
      "scountry as country, "\
      "round(avg(w.price),2) as price,"\
      "max(cast(cast(godendo as dm_date) as dm_text)) as expiration_date,"\
      "((select list(distinct group_id) from PR_GET_GROUP_TO_SITE(w.name_id))) as group_id,"\
      "sname,"\
      "'{'''||(select list(pim.filename, ''',''') from pi$images pim where pim.barcode = w.bcode_izg)||'''}' as photo_id "\
      " from warebase_g w where sname is not null and quant > 0 "\
      "  group by  sname, sizg, scountry, bcode_izg, ware_id, name_id";
LogIt(sql)
result = lan_fdb.get_sql(curs, sql)
res=[]
for line in result:
#    if os.path.isfile(declare.dir_pic + "\\_pict" + "\\"+line[9]):
        res.append({"nomenclature_id":line[0],"catalog_id":line[1],"barcode":line[2],"manufacturer":line[3],"country":line[4],"price":line[5],"expiration_date":line[6],"group_id":line[7],"sname":line[8],"photo_id":[line[9]]})
#    else:
#        res.append({"nomenclature_id":line[0],"catalog_id":line[1],"barcode":line[2],"manufacturer":line[3],"country":line[4],"price":line[5],"expiration_date":line[6],"group_id":line[7],"sname":line[8],"photo_id":[]})


filename =declare.dir+"nomenclature.json"
with open(filename, 'w', encoding='cp1251') as f:
     json.dump(res, f, ensure_ascii=False, indent=4)

#exit()

#################################################################################################################################
#4 quantities - складские остатки
LogIt("8 quantities - складские остатки")

#0 nomenclature_id | guid
#1 store_id | guid
#2 amount | int

sql = "select nomenclature_id, store_id, amount from "\
      "  (select ware_id as nomenclature_id,"\
      "          round(sum(quant),0) as amount,"\
      "           w.g$profile_id as store_id "\
      "   from warebase_g w where sname is not null and quant > 0 "\
      "   group by  ware_id, w.g$profile_id "\
      ") where  amount > 0";
LogIt(sql)

result = lan_fdb.get_sql(curs, sql)
res=[]
for line in result:
    res.append({"nomenclature_id":line[0],"store_id":line[1],"amount":line[2]})
#print(res)

filename =declare.dir+"quantities.json"
with open(filename, 'w', encoding='cp1251') as f:
     json.dump(res, f, ensure_ascii=False, indent=4)


#################################################################################################################################
#Архивирование файлов
#################################################################################################################################
LogIt("Архивирование файлов")
shutil.make_archive(declare.dir+'picts', 'zip', declare.dir_pic_curr)

LogIt("перенос новых сжатых фото в общий локальный каталог dir_pic_all")
filelist = os.listdir(declare.dir_pic_curr+"_pict/")
for file in filelist:
  os.rename(declare.dir_pic_curr+"_pict/" + file, declare.dir_pic_all + file)

zipFile = zipfile.ZipFile(declare.dir+'stores.zip', 'w', zipfile.ZIP_DEFLATED)
zipFile.write(declare.dir+'stores.json', arcname='stores.json')
zipFile.close()

zipFile = zipfile.ZipFile(declare.dir+'nomenclature.zip', 'w', zipfile.ZIP_DEFLATED)
zipFile.write(declare.dir+'nomenclature.json', arcname='nomenclature.json')
zipFile.close()

zipFile = zipfile.ZipFile(declare.dir+'catalog.zip', 'w', zipfile.ZIP_DEFLATED)
zipFile.write(declare.dir+'catalog.json', arcname='catalog.json')
zipFile.close()

zipFile = zipfile.ZipFile(declare.dir+'quantities.zip', 'w', zipfile.ZIP_DEFLATED)
zipFile.write(declare.dir+'quantities.json', arcname='quantities.json')
zipFile.close()

#sys.exit

#################################################################################################################################
#Выгрузка на API
#################################################################################################################################
LogIt("Выгрузка на API")

crl = pycurl.Curl()
crl.setopt(crl.CAINFO, certifi.where())

crl.setopt(crl.URL, declare.url)
crl.setopt(crl.HTTPPOST, [('fileupload', (crl.FORM_FILE, declare.dir+'picts.zip',crl.FORM_FILENAME, 'picts.zip', crl.FORM_CONTENTTYPE, 'application/zip',)),])
crl.perform()
LogIt('picts.zip ' + 'Status: %d' % crl.getinfo(crl.RESPONSE_CODE) + ' Time: %f' % crl.getinfo(crl.TOTAL_TIME))

#список аптек теперь редактируется в админке сайта
#crl.setopt(crl.URL, declare.url)
#crl.setopt(crl.HTTPPOST, [('fileupload', (crl.FORM_FILE, declare.dir+'stores.zip',crl.FORM_FILENAME, 'stores.zip', crl.FORM_CONTENTTYPE, 'application/zip',)),])
#crl.perform()
#LogIt('stores.zip ' + 'Status: %d' % crl.getinfo(crl.RESPONSE_CODE) + ' Time: %f' % crl.getinfo(crl.TOTAL_TIME))

crl.setopt(crl.URL, declare.url)
crl.setopt(crl.HTTPPOST, [('fileupload', (crl.FORM_FILE, declare.dir+'nomenclature.zip',crl.FORM_FILENAME, 'nomenclature.zip', crl.FORM_CONTENTTYPE, 'application/zip',)),])
crl.perform()
LogIt('nomenclature.zip ' + 'Status: %d' % crl.getinfo(crl.RESPONSE_CODE) + ' Time: %f' % crl.getinfo(crl.TOTAL_TIME))

crl.setopt(crl.URL, declare.url)
crl.setopt(crl.HTTPPOST, [('fileupload', (crl.FORM_FILE, declare.dir+'catalog.zip',crl.FORM_FILENAME, 'catalog.zip', crl.FORM_CONTENTTYPE, 'application/zip',)),])
crl.perform()
LogIt('catalog.zip ' + 'Status: %d' % crl.getinfo(crl.RESPONSE_CODE) + ' Time: %f' % crl.getinfo(crl.TOTAL_TIME))

crl.setopt(crl.URL, declare.url)
crl.setopt(crl.HTTPPOST, [('fileupload', (crl.FORM_FILE, declare.dir+'quantities.zip',crl.FORM_FILENAME, 'quantities.zip', crl.FORM_CONTENTTYPE, 'application/zip',)),])
crl.perform()
LogIt('quantities.zip ' + 'Status: %d' % crl.getinfo(crl.RESPONSE_CODE) + ' Time: %f' % crl.getinfo(crl.TOTAL_TIME))


crl.close()
LogIt("Окончание выгрузки")

#ftp = FTP()
#ftp.connect('195.210.47.231', 21)
#ftp.login('admin_standart', 'ExHdGPXga4EZrGOE')
#ftp.set_pasv(True)
#ftp.storlines("STOR " + file_name, open(filename, 'rb'))
#ftp.quit()